<template>
  <dropdown :isBtnActive="!!filter.value.length">

    <template v-slot:btn>

      <template v-if="!filter.value.length">
        {{ filter.name }}
        <icon-small-arrow class="dropdown__icon"/>
      </template>

      <template v-else>

        <template v-if="filter.type === 'time'">
          {{ filter.value[0] }} - {{ filter.value[1] }}
        </template>

        <template v-else>
          {{ filter.value[0] }} - {{ filter.value[1] }}&nbsp;<span v-html="filter.label" class="dropdown__symbol"></span>
        </template>

        <span @click="clearValue" class="dropdown__icon-wrapper">
          <icon-cross class="dropdown__icon"/>
        </span>
      </template>

    </template>

    <template v-slot:body>

      <range-with-inputs :minValue="Number(filter.values[0])"
                         :maxValue="Number(filter.values[1])"
                         :filterType="filter.type"
                         :timeFlags="filter.type === 'time' ? checkedTimeFlags : ''"
                         :symbol="filter.label"
                         v-model="filter.value"
                         ref="rangeWithInputs">

        <template v-if="filter.type === 'time'" v-slot:checkbox>
          <div class="range-dropdown__checks">

            <checkbox v-for="item in filter.flags" :key="item"
                      name="time-flag" :val="item"
                      v-model="checkedTimeFlags">
              {{ item }}
            </checkbox>

          </div>
        </template>

      </range-with-inputs>

    </template>

  </dropdown>
</template>

<script>
  import Dropdown from './Dropdown';
  import RangeWithInputs from '../RangeWithInputs';
  import IconSmallArrow from '../icons/IconSmallArrow';
  import IconCross from '../icons/IconCross';
  import closeDropdowns from '../../assets/js/helpers/close-dropdowns';
  import Checkbox from '../Checkbox';

  export default {
    name: 'RangeDropdown',
    props: {
      filter: {
        type: Object,
        required: true
      }
    },
    components: {
      Checkbox,
      IconCross,
      IconSmallArrow,
      RangeWithInputs,
      Dropdown,
    },
    data: () => ({
      checkedTimeFlags: []
    }),
    watch: {
      filter: {
        deep: true,

        handler() {
          if (!this.filter.value.length) {
            this.$refs.rangeWithInputs.reset();
            this.checkedTimeFlags = [];
          }
        }
      }
    },
    methods: {
      clearValue(event) {
        event.stopPropagation();
        this.$emit('clearValue');

        this.$refs.rangeWithInputs.reset();
        this.checkedTimeFlags = [];
        closeDropdowns();
      }
    },
  }
</script>

<style scoped lang="scss">
  @import '~assets/scss/variables.scss';
  @import '~assets/scss/mixins.scss';

  .range-dropdown {
    &__checks {
      display: flex;
      margin-bottom: rem(30);

      .checkbox + .checkbox {
        margin-left: rem(30);
      }
    }
  }

</style>
